unit DMPluginIntf;

// For description see readme.txt

interface

type
  { IDMInterface }
  IDMInterface = interface(IUnknown)
  ['{B412B405-0578-4B99-BB06-368CDA0B2F8C}']
    function DoAction(action: WideString; parameters: WideString): WideString; stdcall;//execute some actions in IDA
  end;

  { IDMPlugIn }
  IDMPlugIn = interface(IUnknown)
  ['{959CD0D3-83FD-40F7-A75A-E5C6500B58DF}']
    function getID: WideString; stdcall;
    //-----info
    function GetName: WideString; stdcall;//get plug-in info
    function GetVersion: WideString; stdcall;//get plug-in info
    function GetDescription(language: WideString): WideString; stdcall;//get plug-in info
    function GetEmail: WideString; stdcall;//get plug-in info
    function GetHomepage: WideString; stdcall;//get plug-in info
    function GetCopyright: WideString; stdcall;//get plug-in info
    function GetMinAppVersion: WideString; stdcall;//get minimum version of IDA with which a plug-in can work
    //------
    procedure PluginInit(_IDmInterface: IDmInterface); stdcall;//initialize plug-in and pass interface to access IDA
    procedure PluginConfigure(params: WideString); stdcall;//show plug-in configuration window
    procedure BeforeUnload; stdcall;

    function EventRaised(eventType: WideString; eventData: WideString): WideString; stdcall;//called from IDA when an event occurs
    { plug-in ID }
    property ID: WideString read getID;
  end;

implementation

end.
